#include <amxmodx>
#include <engine>
#include <fakemeta_util>
#include <hamsandwich>
#include <zombie_plague_special>

#define PLUGIN  "[ZPSP] Addon: Death Crystal"
#define VERSION "1.0"
#define AUTHOR  "Wilian M."

#define CRYSTAL_CLASSNAME "wmxacalaca"
#define CRYSTAL_SOUNDPICK "crystal/crystal_pickup.wav"
#define CRYSTAL_MODEL "models/crystal/crystal.mdl"
#define PREFIX_CHAT "^4[CS Revo]"

new xMsgIdScreenFade, xCvarMinPacks, xCvarMaxPacks, xCvarRemoveNewRound

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	register_event("HLTV", "Event_NewRound", "a", "1=0", "2=0")
	register_touch(CRYSTAL_CLASSNAME, "player", "fw_CrystalTouch")
	RegisterHam(Ham_Killed, "player", "fw_PlayerKilled_Post", true)

	xMsgIdScreenFade = get_user_msgid("ScreenFade")

	xCvarMinPacks = register_cvar("crystal_min_packs", "0")
	xCvarMaxPacks = register_cvar("crystal_max_packs", "5")
	xCvarRemoveNewRound = register_cvar("crystal_remove_new_round", "1")
}

public plugin_precache()
{
	precache_model(CRYSTAL_MODEL)
	precache_sound(CRYSTAL_SOUNDPICK)
}

public Event_NewRound()
{
	if(get_pcvar_num(xCvarRemoveNewRound))
		remove_entity_name(CRYSTAL_CLASSNAME)
}

public fw_PlayerKilled_Post(Victim, Attacker)
{
	if(zp_get_user_zombie(Victim) || zp_get_zombie_special_class(Victim))
	{
		static Float:Origin[3]
		pev(Victim, pev_origin, Origin)

		xCreateCrystal(Origin)
	}
}

public fw_CrystalTouch(Ent, id)
{
	if(!pev_valid(Ent))
		return

	if(!is_user_alive(id))
		return

	if(zp_get_user_zombie(id) || zp_get_zombie_special_class(id))
		return
		
	message_begin(MSG_ONE_UNRELIABLE, xMsgIdScreenFade, _, id)
	write_short((1<<12) * 1) // duration
	write_short(0) // hold time
	write_short(0x0000) // fade type
	write_byte(127) // red
	write_byte(255) // green
	write_byte(127) // blue
	write_byte(50) // alpha
	message_end()
	
	new x
	x = random_num(get_pcvar_num(xCvarMinPacks), get_pcvar_num(xCvarMaxPacks))
	zp_set_user_ammo_packs(id, zp_get_user_ammo_packs(id) + x)
	emit_sound(Ent, CHAN_ITEM, CRYSTAL_SOUNDPICK, VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
	client_print_color(id, print_team_default, "%s ^3Você ganhou ^4+%d ^3ammo packs.", PREFIX_CHAT, x)

	set_pev(Ent, pev_flags, FL_KILLME)
	set_pev(Ent, pev_nextthink, get_gametime() + 0.01)
}

public xCreateCrystal(Float:Origin[3])
{
	static Ent
	Ent = create_entity("info_target")
		
	set_pev(Ent, pev_classname, CRYSTAL_CLASSNAME)
	engfunc(EngFunc_SetModel, Ent, CRYSTAL_MODEL)

	engfunc(EngFunc_SetSize, Ent, Float:{-16.0,-16.0,0.0}, Float:{16.0,16.0,16.0})
	
	set_pev(Ent, pev_solid, SOLID_TRIGGER)
	set_pev(Ent, pev_movetype, MOVETYPE_TOSS)

	static Float:Ori[3]; Ori = Origin; Ori[2] += 8.0
	engfunc(EngFunc_SetOrigin, Ent, Ori)
	
	fm_set_rendering(Ent, kRenderFxGlowShell, 100, 255, 100, kRenderNormal, 0)
	set_pev(Ent, pev_light_level, 180)
	
	set_pev(Ent, pev_animtime, get_gametime())
	set_pev(Ent, pev_framerate, 1.0)
	set_pev(Ent, pev_sequence, 0)
	
	return Ent
}